import request, { apis } from './request'

const pages = require('../pages')

/**
 * 用户来源
 * @param {*} router 
 */
// eslint-disable-next-line import/prefer-default-export
export async function trackUserSource(router, qrcode) {
  const { path, scene, params } = router || {}

  const pageInfo = pages.filter(x => path.indexOf(x.page) > -1)[0] || { type: 'other', name: '其他' }

  const trackPayload = {
    event: 'start',
    eventType: pageInfo.type,
    propertyName: pageInfo.name,
    data: '{}',
    id: params.id,
    buildingId: undefined,
    realScene: scene,
    sceneId: params.scene,
    sharePersonId: (qrcode || {}).recommender || params.recommender,
  }

  try {
    const sceneList = [1005, 1006, 1053, 1042, 1007, 1008, 1011, 1012, 1013, 1045, 1046, 1047, 1048, 1058, 1067, 1000]

    if (sceneList.indexOf(trackPayload.sceneId) === -1) {
      trackPayload.sceneId = 1000
    }
    const { recordId } = await request({ ...apis.saveTracking, silent: true, data: trackPayload })

    return () => request({ ...apis.updateTracking, silent: true, args: { id: recordId } })
  } catch (e) {
    console.error('进入小程序埋点出错:', e);
    return function () { }
  }
}
